'use strict';

var ChainedMap = require('webpack-chain/src/ChainedMap');
var Plugin = require('./Plugin');
var Options = require('./Options');

module.exports = (function (ChainedMap) {
  function MarkdownItChain() {
    ChainedMap.call(this);
    this.options = new Options(this);
    this.plugins = new ChainedMap(this);
  }

  if ( ChainedMap ) MarkdownItChain.__proto__ = ChainedMap;
  MarkdownItChain.prototype = Object.create( ChainedMap && ChainedMap.prototype );
  MarkdownItChain.prototype.constructor = MarkdownItChain;

  MarkdownItChain.prototype.toConfig = function toConfig () {
    return this.clean(Object.assign(this.entries() || {}, {
      options: this.options.entries(),
      plugins: this.plugins.values().map(function (plugin) { return plugin.toConfig(); })
    }));
  };

  MarkdownItChain.prototype.plugin = function plugin (name) {
    if (!this.plugins.has(name)) {
      this.plugins.set(name, new Plugin(this));
    }

    return this.plugins.get(name);
  };

  MarkdownItChain.prototype.toMd = function toMd () {
    var ref = this.toConfig();
    var options = ref.options;
    var plugins = ref.plugins;
    var md = require('markdown-it')(options);
    return plugins.reduce(function (md, ref) {
      var plugin = ref.plugin;
      var args = ref.args;

      return md.use.apply(md, [ plugin ].concat( args ));
    }, md);
  };

  return MarkdownItChain;
}(ChainedMap));
